#include <avr/io.h>
#include <avr/interrupt.h>
#include "profiling.h"


void PROFILING_Start (void)
{
	/* Reset TIMER1 count value */
	TCNT1 = 0;

	/* Setup prescaler to clk_io/64 */
	TCCR1B = (1 << CS10);	
}

unsigned int PROFILING_End (void)
{
	unsigned char sreg;
	unsigned int i;

	/* Save global interrupt flag */
	sreg = SREG;

	/* Disable interrupts */
	cli();

	/* Read TCNTn into i */
	i = TCNT1;

	/* Restore global interrupt flag */
	SREG = sreg;

	/* Stop timer1 */
	TCCR1B = 0;

	return i;
}
