#include <stdio.h>
#include <math.h>
#include <mex.h>

void matrisemul( double *CC, double *AA,  double *BB,int sizeAm, int sizeAn, int sizeBm,int sizeBn)
{
    int i;
    int j;
    int k;
    double sum;
    for (i = 0; i<sizeAn;i++){
        for(j = 0; j<sizeBn; j++){
            sum = 0;
            for(k = 0; k<sizeBm;k++){
            sum = sum + AA[i*sizeAn+k]*BB[k*sizeBn+j];
            }
            CC[i*sizeBn+j] = sum;
        }
    }
}

void mexFunction(int nlhs, mxArray *plhs[],int nrhs, const mxArray *prhs[]){
	// Input variables
    double lat, w_B_IB[3], quaternions[4], eps[3], eta;
    double w_o, Rc, Nx, Ny, Nz, Ax, Ay, Az, pi;
    double R11, R12, R13, R21, R22, R23, R31, R32, R33;
    double R_O_B[9], R_B_O[9], w_B_OB[3];
    double B0, Bn, Br;
    double B_O[3], B_B[3];
    double m_B[3], ix, iy, iz;
    
    lat = 0;
	w_B_IB[0] = 0.1000;
    w_B_IB[1] = -0.0008;
    w_B_IB[2] = 0.0008;
	quaternions[0] = 0.3827;
    quaternions[1] = 0;
    quaternions[2] = 0;
    quaternions[3] = 0.9239;
	eps[0] = 0;
    eps[1] = 0;
    eps[2] = 0;
    eta = 0;
    eps[0] = quaternions[0];
    eps[1] = quaternions[1];
    eps[2] = quaternions[2];
    eta = quaternions[3];

	// Constant/parameter assignment
    w_o = 0.0011;
	Rc = 6971200;
	Nx = 100;
	Ny = 100;
	Nz = 100;
	Ax = 75*pow(10,-4);
	Ay = 150*pow(10,-4);
	Az = 150*pow(10,-4);
	pi = 3.1415926535;

	// R_O_B = eye(3) + 2*eta*S_eps + 2*S_eps^2;
	R11 = 1-2*eps[1]*eps[1]-2*eps[2]*eps[2];
	R12 = -2*eta*eps[2]+2*eps[0]*eps[1];
	R13 = 2*eta*eps[1]+2*eps[0]*eps[2];
	R21 = 2*eta*eps[2]+2*eps[0]*eps[1];
	R22 = 1-2*eps[0]*eps[0]-2*eps[2]*eps[2];
	R23 = -2*eta*eps[0]+2*eps[1]*eps[2];
	R31 = 2*eta*eps[1]+2*eps[0]*eps[2];
	R32 = 2*eta*eps[0]+2*eps[1]*eps[2];
	R33 = 1-2*eps[0]*eps[0]-2*eps[1]*eps[1];
    R_O_B[0] = R11;
    R_O_B[1] = R12;
    R_O_B[2] = R13;
    R_O_B[3] = R21;
    R_O_B[4] = R22;
    R_O_B[5] = R23;
    R_O_B[6] = R31;
    R_O_B[7] = R32;
    R_O_B[8] = R33;
	// R_B_O = R_O_B';
    R_B_O[0] = R11;
    R_B_O[1] = R21;
    R_B_O[2] = R31;
    R_B_O[3] = R12;
    R_B_O[4] = R22;
    R_B_O[5] = R32;
    R_B_O[6] = R13;
    R_B_O[7] = R23;
    R_B_O[8] = R33;

	// w_O_IO = [0;-w_o;0];
	// w_B_OB = w_B_IB-R_B_O*w_O_IO;
	w_B_OB[0] = w_B_IB[0]+R21*w_o;
    w_B_OB[1] = w_B_IB[1]+R22*w_o;
    w_B_OB[2] = w_B_IB[2]+R23*w_o;

	// Detumbling controller
	// [tau_m,w] = detumblingController1(P,w_B_OB,lat)
	// [B_O,~] = dipoleField(P,lat);
	B0 = pow(10,17)/(4*pi*pow(Rc,3));
	Bn = B0*cos(lat);
	Br = 2*B0*sin(lat);
	B_O[0] = Bn;
    B_O[1] = 0;
    B_O[2] = Br;
	// B_B = R_B_O*B_O;
	matrisemul(B_B,R_B_O,B_O,3,3,1,3);
	// ELIMINTATED "1/norm(B_B,2)^2" from the matlab code.
	// d = diag(1e4*[1 1 2]); This has changed here because of the elimination above
	// m_B = -d*cross(B_B,w_B_OB);
	m_B[0] = pow(10,4)*B_B[2]*w_B_OB[1]-pow(10,4)*B_B[1]*w_B_OB[2];
    m_B[1] = -pow(10,4)*B_B[2]*w_B_OB[0]+pow(10,4)*B_B[0]*w_B_OB[2];
    m_B[2] = 2*pow(10,4)*B_B[1]*w_B_OB[0]-2*pow(10,4)*B_B[0]*w_B_OB[1];
	//
	//[m_B,w] = momentumScaling(P,m_B);
	//
	// tau_m = cross(m_B,B_B); 

	ix = m_B[0]/(Nx*Ax);
	iy = m_B[1]/(Ny*Ay);
	iz = m_B[2]/(Nz*Az);
	// NEXT STEP IS TO TURN ix, iy and iz INTO  a PWM signal

	printf("%13.10f,%13.10f,%13.10f\n", ix, iy, iz);
    //printf("Hello World"); 
}


