function field = dipoleField2(lat)
my_m = 1e17/(4*pi);
Re = 6370e3;
r = 600e3;
Rc = Re+r;
B0 = my_m/Rc^3;

Bn = B0*cos(lat);       % x-axis in orbital frame, parallel to the velocity vector
Br = 2*B0*sin(lat);     % z-axis in orbital frame, toward Earth center

field = [Bn;0;Br];

end